
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>我的 Android 开发实战经验总结 / iVAN</title>

    <meta name="description" content="我的 Android 开发实战经验总结 我的 Android 开发实战经验总结 字数4440 阅读5137 评论43 喜欢250 以前一直想写一篇总结 Android 开发经验的文章,估计当时的我还达不到某种水平,所以思路跟不上,下笔又捉襟见肘.近日,思路较为明朗,于是重新操起键盘开始码字一番.先声明一下哈,本人不是大厂的程序猿.去年毕业前,就一直在当前创业小团队从事自己热爱的打码事业至今.下面总结是建立在我当前的技术水平和认知上写的,如有不同看法欢迎留下评论互相交流. 1.理解抽象,封装变化 目前 Android 平台上绝大部分开发">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">我的 Android 开发实战经验总结</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h1>我的 Android 开发实战经验总结</h1>
<p>字数4440 阅读5137 评论43 喜欢250</p>
<p>以前一直想写一篇总结 Android 开发经验的文章，估计当时的我还达不到某种水平，所以思路跟不上，下笔又捉襟见肘。近日，思路较为明朗，于是重新操起键盘开始码字一番。<strong>先声明一下哈，本人不是大厂的程序猿。去年毕业前，就一直在当前创业小团队从事自己热爱的打码事业至今。下面总结是建立在我当前的技术水平和认知上写的，如有不同看法欢迎留下评论互相交流。</strong></p>
<h2>1.理解抽象，封装变化</h2>
<p>目前 Android 平台上绝大部分开发都是用着 Java ，而跟 Java 这样一门面向对象的语言打交道，不免要触碰到 <strong>抽象</strong> 和 <strong>封装</strong> 的概念。我身边接触过的一些开发者，有一部分还对这些概念停留在写一个抽象类、接口、或者一个方法（或抽象方法）。至于为什么，我不大清楚是他们表达不出来，还是不理解。下面我也不高谈阔论，直接举例子来解释我所理解的抽象。</p>
<pre><code>//Activity 间使用 Intent 传递数据的两种写法 下面均是伪代码形式，请忽略一些细节

//写法一

//SrcActivity 传递数据给 DestActivity
Intent intent = new Intent(this,DestActivity.class);
intent.putExtra("param", "clock");
SrcActivity.startActivity(intent);

//DestActivity 获取 SrcActivity 传递过来的数据
String param = getIntent.getStringExtra("param");

//写法二

//SrcActivity 传递数据给 DestActivity
Intent intent = new Intent(this,DestActivity.class);
intent.putExtra(DestActivity.EXTRA_PARAM, "clock");
SrcActivity.startActivity(intent);

//DestActivity 获取 SrcActivity 传递过来的数据
public final static String EXTRA_PARAM = "param";
String param = getIntent.getStringExtra(EXTRA_PARAM);</code></pre>
<p>写法一，存在的问题是，如果 SrcActivity 和 DestActivity 哪个把 "param" 打错成 "para" 或者 "paran" ，传递的数据都无法成功接收到。而写法二则不会出现此类问题，因为两个 Activity 之间传递数据只需要知道 EXTRA_PARAM 变量即可，至于 EXTRA_PARAM 变量到底是 "param" 、 "para" 、"paran" 这一点并不需要关心，这就是一种对可能发生变化的地方进行抽象封装的体现，它所带来的好处就是降低手抖出错的概率，同时方便我们进行修改。</p>
<p>基于抽象和封装，Java 本身很多 API 在设计上就有这样的体现，如 Collections 中的很多排序方法：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvdXBsb2FkLWltYWdlcy5qaWFuc2h1LmlvL3VwbG9hZF9pbWFnZXMvOTEyMTgxLTQzZDkxYzA5YjBjZjhjOGMuanBnP2ltYWdlTW9ncjIvYXV0by1vcmllbnQvc3RyaXAlN0NpbWFnZVZpZXcyLzIvdy8xMjQw.jpg"></p>
<p>Collections中的排序API</p>
<p>这些方法都是基于 List 这个抽象的列表接口进行排序，至于这是一个用什么样的数据结构实现 List（ArrayList 还是 LinkedList），排序方法本身并不关心。看，是不是体现了 JDK 的设计人员的一种抽象编程的思维，因为 List 的具体实现可能有千万种，如果每一类 List 都要写一套排序方法，估计要哭瞎了。</p>
<blockquote><p>小结：把容易出现变化的部分进行抽象，就是对变化的一种封装。</p></blockquote>
<h2>2.选好"车轮"</h2>
<p>一个项目的开发，我们不可能一切从0做起，如果真是这样，那同样要哭瞎。因此，善于借用已经做好的 "车轮" 非常重要，如：</p>
<p>网络访问框架：okhttp、retrofit、android-async-http、volley<br />
图片加载框架：Android-Universal-Image-Loader、Glide、Fresco、Picasso<br />
缓存框架：DiskLruCache、 Robospice<br />
Json解析框架：Gson、Fastjson、Jackson<br />
事件总线：EventBus、Otto<br />
ORM框架：GreenDAO、Litepal<br />
还有其他各种各样开源的自定义控件、动画等。除了以上提到的开源框架，也包括一些不开源的SDK<br />
数据统计：友盟统计，百度统计...<br />
奔溃搜集：腾讯bugly、bugtags...<br />
云存储：七牛...<br />
即使通讯：环信、融云、阿里百川...<br />
推送：小米推送、腾讯推送、百度推送...<br />
安全加固：360加固宝、爱加密...</p>
<p>一般情况下，我在选择是否引入一些开源框架主要基于以下几个因素：</p>
<ul>
<li>借助搜索引擎，如果网上有一大波资料，说明使用的人多，出了问题好找解决方案；当然，如果普遍出现差评，就可以直接Pass掉了</li>
<li>看框架的作者或团队，如 <a href="https://github.com/JakeWharton" rel="external nofollow noreferrer">JakeWharton大神</a>、<a href="https://code.facebook.com/" rel="external nofollow noreferrer">Facebook团队</a>等。大神和大公司出品的框架质量相对较高，可保证后续的维护和bug修复，不容易烂尾；</li>
<li>关注开源项目的 commit密度，issue的提交、回复、关闭数量，watch数，start数，fork数等。像那种个基本不怎么提交代码、提issue又不怎么回复和修复的项目，最好就pass掉；</li>
</ul>
<p>针对不开源SDK的选择，也主要基于以下几点去考虑：</p>
<ul>
<li>借助搜索引擎，查明口碑；</li>
<li>很多第三方SDK的官网首页都会告诉你，多少应用已经接入了此SDK，如果你看到有不少知名应用在上面，那这个SDK可以考虑尝试一下了。诸如，友盟官网：</li>
</ul>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvdXBsb2FkLWltYWdlcy5qaWFuc2h1LmlvL3VwbG9hZF9pbWFnZXMvOTEyMTgxLTk4MmQ3OTBhMDc0ZTE2NjkuanBnP2ltYWdlTW9ncjIvYXV0by1vcmllbnQvc3RyaXAlN0NpbWFnZVZpZXcyLzIvdy8xMjQw.jpg"></p>
<p>接入友盟的App</p>
<ul>
<li>查看SDK使用文档、它们的开发者社区、联系客服。好的SDK，使用文档肯定会详细指引你。出了问题，上开发者社区提问，他们的开发工程师也会社区上回答。实在不行只能联系客服，如果客服的态度都让你不爽，那就可以考虑换别家的SDK了。</li>
</ul>
<blockquote><p>小结：选好 "车轮" ，事半功倍</p></blockquote>
<h2>3.抽象依赖第三方框架</h2>
<p>为什么要抽象依赖于第三方框架呢？这里和第1点是互相照应的，就是降低我们对具体某个框架的依赖性，从而方便我们快速切换到不同的框架去。说到这里，你可能觉得很抽象，那我直接举一个加载图片的例子好了。</p>
<p>假设你当前为项目引入一个加载图片的框架 —— Android-Universal-Image-Loader，最简单的做法就是加入相应的依赖包后，在任何需要加载图片的地方写上下面这样的代码段。</p>
<pre><code>ImageLoader imageLoader = ImageLoader.getInstance(); // Get singleton instance
// Load image, decode it to Bitmap and display Bitmap in ImageView (or any other view
//  which implements ImageAware interface)
imageLoader.displayImage(imageUri, imageView);
// Load image, decode it to Bitmap and return Bitmap to callback
imageLoader.loadImage(imageUri, new SimpleImageLoadingListener() {
    @Override
    public void onLoadingComplete(String imageUri, View view, Bitmap loadedImage) {
        // Do whatever you want with Bitmap
    }
});</code></pre>
<p>这种做法最简单粗暴，但是带来的问题也最严重的。如果我有几十上百个地方都这么写，而在某一天，我听说Facebook出了个神器 Fresco，想要换掉 Android-Universal-Image-Loader ，你就会发现你需要丧心病狂的去改动几十上百个地方的代码，不仅工作量大，而且还容易出错。造成这样的原因，就在于项目和加载图片的框架之间形成了<strong>强耦合</strong>，而实际上，项目本身不应该知道我具体用了哪个加载图片的框架。</p>
<p>正确的方式，应该是对框架做一个抽象的封装，以应对未来发生的变化，我直接举自己的开源项目 <a href="https://github.com/D-clock/AndroidAlbum" rel="external nofollow noreferrer">AndroidAlbum</a> 中的一种封装做法好了。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvdXBsb2FkLWltYWdlcy5qaWFuc2h1LmlvL3VwbG9hZF9pbWFnZXMvOTEyMTgxLTEzZjUzNzk3MTcxZDBiZTguanBnP2ltYWdlTW9ncjIvYXV0by1vcmllbnQvc3RyaXAlN0NpbWFnZVZpZXcyLzIvdy8xMjQw.jpg"></p>
<p>AndroidAlbum</p>
<p>大致代码如下：</p>
<pre><code>//1、声明 ImageLoaderWrapper 接口，定义一些抽象的加载接口方法

public interface ImageLoaderWrapper {

    /**
     * 显示 图片
     *
     * @param imageView 显示图片的ImageView
     * @param imageFile 图片文件
     * @param option    显示参数设置
     */
    public void displayImage(ImageView imageView, File imageFile, DisplayOption option);

    /**
     * 显示图片
     *
     * @param imageView 显示图片的ImageView
     * @param imageUrl  图片资源的URL
     * @param option    显示参数设置
     */
    public void displayImage(ImageView imageView, String imageUrl, DisplayOption option);

    /**
     * 图片加载参数
     */
    public static class DisplayOption {
        /**
         * 加载中的资源id
         */
        public int loadingResId;
        /**
         * 加载失败的资源id
         */
        public int loadErrorResId;
    }
}

// 2、将 UniversalAndroidImageLoader 封装成继承 ImageLoaderWrapper 接口的 UniversalAndroidImageLoader ，
//这里代码有点长，感兴趣可以查看项目源码中的实现 https://github.com/D-clock/AndroidAlbum

// 3、做一个ImageLoaderFactory

public class ImageLoaderFactory {

    private static ImageLoaderWrapper sInstance;

    private ImageLoaderFactory() {

    }

    /**
     * 获取图片加载器
     *
     * @return
     */
    public static ImageLoaderWrapper getLoader() {
        if (sInstance == null) {
            synchronized (ImageLoaderFactory.class) {
                if (sInstance == null) {
                    sInstance = new UniversalAndroidImageLoader();//&lt;link&gt;https://github.com/nostra13/Android-Universal-Image-Loader&lt;/link&gt;
                }
            }
        }
        return sInstance;
    }
}

//4、在所有需要加载图片的地方作如下的调用

ImageLoaderWrapper loaderWrapper = ImageLoaderFactory.getLoader();
ImageLoaderWrapper.DisplayOption displayOption = new ImageLoaderWrapper.DisplayOption();
displayOption.loadingResId = R.mipmap.img_default;
displayOption.loadErrorResId = R.mipmap.img_error;
loaderWrapper.displayImage(imagview, url, displayOption);</code></pre>
<p>这样一来，切换框架所带来的代价就会变得很小，这就是不直接依赖于框架所带来的好处。当然，以上只是我比较简单的封装，你也可以进行更加细致的处理。</p>
<blockquote><p>小结：预留变更，不强耦合于第三方框架</p></blockquote>
<h2>4.从 MVC 到 MVP</h2>
<p>说实话，在没接触 MVP 的架构之前，一直都是使用 MVC 的模式进行开发。而随着项目越来越大，Activity或者 Fragment里面代码越来越臃肿，看的时候想吐，改的时候想屎...这里撇开其他各种各样的架构不谈，只对比MVC 和 MVP 。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvdXBsb2FkLWltYWdlcy5qaWFuc2h1LmlvL3VwbG9hZF9pbWFnZXMvOTEyMTgxLTQ0YTViMTRkMjE4MjlmZTguanBnP2ltYWdlTW9ncjIvYXV0by1vcmllbnQvc3RyaXAlN0NpbWFnZVZpZXcyLzIvdy8xMjQw.jpg"></p>
<p>MVC</p>
<ul>
<li>View：布局的xml文件</li>
<li>Controller：Activity、Fragment、Dialog等</li>
<li>Model:相关的业务操作处理数据（如对数据库的操作、对网络等的操作都应该在Model层里）</li>
</ul>
<p>你会发现，如果 View 层只包含了xml文件，那我们 Android 项目中对 View 层可做操作的程度并不大，顶多就是用include复用一下布局。而 Activity 等简直就是一个奇葩，它虽然归属于 Controller 层，但实际上也干着 View 层的活（View 的初始化和相关操作都是在Activity中）。就是这种既是 View 又是 Controller 的结构，违背了单一责任原则，也使得 Activity 等出现了上述的臃肿问题。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvdXBsb2FkLWltYWdlcy5qaWFuc2h1LmlvL3VwbG9hZF9pbWFnZXMvOTEyMTgxLTM4OTNkY2YyYWI4ZGI1NWMuanBnP2ltYWdlTW9ncjIvYXV0by1vcmllbnQvc3RyaXAlN0NpbWFnZVZpZXcyLzIvdy8xMjQw.jpg"></p>
<p>MVP</p>
<ul>
<li>View：Activity、Fragment、Dialog、Adapter等，该层不包含任何业务逻辑</li>
<li>Presenter：中介，View 与 Model 不发生联系，都通过 Presenter 传递</li>
<li>Model:相关的业务操作处理数据（如对数据库的操作、对网络等的操作都应该在Model层里）</li>
</ul>
<p>相比 MVC，MVP在层次划分上更加清晰了，不会出现一人身兼二职的情况（有些单元测试的童鞋，会发现单元测试用例更好写了）。在此处你可以看到 View 和 Model 之间是互不知道对方存在的，这样应对变更的好处更大，很多时候都是 View 层的变化，而 Model 层发生的变化会相对较少，遵循 MVP 的结构开发后，改起来代码来也没那么蛋疼。<br />
这里也有地方需要注意，因为大量的交互操作集中在 Presenter 层中，所以需要把握好 Presenter 的粒度，一个 Activity 可以持有多个 View 和 Presenter，这样也就可以避开一个硕大的 View 和 Presenter 的问题了。</p>
<p>推荐两个不错的 MVP 架构的项目给大家，还不明白的童鞋，可以自行体会一下其设计思想：</p>
<p><a href="https://github.com/pedrovgs/EffectiveAndroidUI" rel="external nofollow noreferrer">https://github.com/pedrovgs/EffectiveAndroidUI</a><br /><a href="https://github.com/antoniolg/androidmvp" rel="external nofollow noreferrer">https://github.com/antoniolg/androidmvp</a></p>
<blockquote><p>小结：去加以实践的理解 MVP 吧</p></blockquote>
<h2>5.归档代码</h2>
<p>把一些常用的工具类或业务流程代码进行归类整理，加入自己的代码库（还没有自己个人代码仓库的童鞋可以考虑建一个了）。如加解密、拍照、裁剪图片、获取系统所有图片的路径、自定义的控件或动画以及其其他他一些常用的工具类等。归档有助于提高你的开发效率，在遇到新项目的时候随手即可引入使用。如果你想要更好的维护自己的代码库，<strong>不妨在不泄露公司机密的前提下，把这个私人代码库加上详细文档给开源出去。</strong>这样能够吸引更多开发者来使用这些代码，也可以获得相应的bug反馈，以便于着手定位修复问题，增强这个仓库代码的稳定性。</p>
<blockquote><p>小结：合理归档代码，可以的话，加以开源维护</p></blockquote>
<h2>6.性能优化</h2>
<p>关于性能优化的问题，大体都还是关注那几个方面：内存、CPU、耗电、卡顿、渲染、进程存活率等。对于这些地方的性能优化思路和分析方法，网络上已经有很多答案了，此处不做赘述。我只想说以下几点：</p>
<ul>
<li>不要过早的做性能优化，app先求能用再求好用。在需求都还没完成的时候把大量时间花在优化上是本末倒置的；</li>
<li>优化要用实际数据说话，借助测试工具进行检测（如：网易的Emmagee、腾讯的GT和APT，科大讯飞的iTest，Google的Battery Historian）。毕竟老板问你比以前耗电降低多少，总不能回答降低了一些吧???</li>
<li>任何不以减低性能损耗来做保活的手段，都是耍流氓。</li>
</ul>
<blockquote><p>小结：合理优化，数据量化</p></blockquote>
<h2>7.实践新技术</h2>
<p>Rxjava、React Native、Kotlin...开始兴起后，身边有很多开发者会跟风直上。学习新技术的精神是非常值得鼓励的，但没有经过一段时间实践观察，就擅自把新技术引入到商业项目中，则有失妥当。对于大公司的团队来说，会有专门团队或项目去研究这些新兴技术，以确定是否在自己的产品线开发中引入。但作为小公司，是不是就意味着没有实践尝试新技术的机会呢？并不是！个人有以下几点建议：</p>
<ul>
<li>借助搜索引擎。看此项技术坑多不多，口碑不错但是坑多的话，则说明当前技术不成熟，可以耐心等待更新；</li>
<li>考虑学习成本。学习成本太大且不容易招到懂这方面的开发者的情况下，建议不要引入该技术；</li>
<li>高仿一个项目并开源。如果你想引入 React Native 做商业开发，最好先高仿实现一个应用然后将其开源。这样一些对 RN 感兴趣的开发者会运行你的代码并反馈 bug 给你，有助于你知道一些新技术的坑，并寻找相应的解决方案，最终确定是否引入该技术；</li>
<li>降低入门门槛。实践新技术的过程尽量加以详细的文档记录，这会有助于降低项目组其他同事对新技术的入门门槛，可以的话，也将学习文档开源，获得更多开发者对此份文档的反馈，也可纠正一些文档中的错误；</li>
<li>结合实际业务。所有新技术的引入都要考虑是否符合当下的业务需求，我听过有些程序猿想引入新技术的原因是因为觉得这种技术很酷，网上说很好用，很啥啥啥...自己完全没弄过就人云亦云。有时候好无语，感觉在会用一些技术就像在炫技一样；</li>
</ul>
<blockquote><p>小结：空谈误国，实干兴邦</p></blockquote>
<h2>8.UML</h2>
<p>UML，驯服代码和了解项目结构的利器，本人也在学习和体验其好处的路途上。不管遇到大小项目，有了它，可以更好的理清一些脉络结构。对付旧的庞大项目代码，或者有志阅读某些开源项目代码的开发者，绝对是居家必备。</p>
<blockquote><p>小结：工欲善其事，必先利其器</p></blockquote>
<h2>9.自造"车轮"</h2>
<p>前面 2 提到，项目不可能从0开始，是需要引入很多第三方框架的。这里并不与 2 互相违背，而是建议有想提高技术逼格的开发者，可以在空暇时间去编码实现一个框架。如果你对网络访问、图片加载方面很有研究见解，不妨把这些脑海里的思想落实成具体的代码。也许你会发现，你动手去实践的时候，考虑的东西会多得多，自己最终得到的也会更多。（<strong>特别建议那些看过很多开源代码，又至今未自己动手自撸一发的</strong>）</p>
<blockquote><p>小结：不要停留在 api 调用的层面</p></blockquote>
<h2>10.扩大技术圈</h2>
<p>有空又经济能力承受得起的时候，不妨去参加一些自己感兴趣的技术交流会。很多都有大牛上台演讲，听听人家的解决方案，拓宽一下自己看问题的思路，也可以多参加一些含金量高的线上活动。我有挺多开发者朋友，就是参加活动的时候认识的，有时候遇到一些技术问题，还会互相探讨交换一下解决思路。挺赞的！</p>
<blockquote><p>小结：拓宽技术视野</p></blockquote>
<h2>11.写博客总结</h2>
<p>这个可能没什么好说的，大家看了标题就懂了。它最大的好处在于：</p>
<ul>
<li>系统化记录自己的解决方案；</li>
<li>方便日后自己回顾；</li>
<li>有问题也会有读者评论反馈，促进技术交流；</li>
<li>增强自己书面表达能力；</li>
</ul>
<blockquote><p>小结：认真总结，不断完善</p></blockquote>
<h2>12.找个对象</h2>
<p>程序猿不要老是对着电脑，赶紧找个对象提升一下幸福感。据说幸福感高的程序猿，编码效率高，出bug几率小...</p>
<blockquote><p>总结：做个面向对象的程序员</p></blockquote>
<p>大概就想到这些了，以后要是再有想写的，另开新篇。絮絮叨叨写了这么多，最关键的还是自己要落实，千万不要听说过太多道理，却依然过不好这一生哈！！！！</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 17:46:11</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>我的 Android 开发实战经验总结的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0Qae6p.html" rel="bookmark">我的Android开发实战经验总结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				以前一直想写一篇总结 Android 开发经验的文章,估计当时的我还达不到某种水平,所以思路跟不上,下笔又捉襟见肘.近日,思路较为明朗,于是重新操起键盘开始码字一番.先声明一下哈,本人不是大厂的程序猿.去年毕业前,就一直在当前创业小团队从事自己热爱的打码事业至今.下面总结是建立在我当前的技术水平和认知上写的,如有不同看法欢迎留下评论互相交流. 1.理解抽象,封装变化 目前 Android 平台上绝大部分开发都是用着 Java ,而跟 Java 这样一门面向对象的语言打交道,不免要触碰到 抽象 和			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdyy84z.html" rel="bookmark">《Java和Android开发实战详解》&mdash;&mdash;2&period;1节如何构建应用程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.1 如何构建应用程序 Java和Android开发实战详解 一般来说,我们使用Java程序语言的目的,就是编写程序代码构建应用程序,以期让计算机执行来解决问题. 2.1.1 如何编写程序代码 程序设计(Programming)很困难吗?事实上,如果你可以引导问路人到达目的地.走迷宫或开车到你家,一步一步详细列出活动流程,就表示你一定可以编写程序代码.不过,在列流程时请注意!计算机一点都不聪明,也不会举一反三,所以,我们需要告诉计算机详细的步骤和信息,不能只有模棱两可的内容. 例如,在北京开车			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/badranz.html" rel="bookmark">《Java和Android开发实战详解》&mdash;&mdash;1&period;1节编程语言基础知识</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.1编程语言基础知识 Java和Android开发实战详解 &quot;编程语言&quot;(Programming Language)是人类告诉计算机如何工作的一款语言,如同人与人之间沟通使用自然语言,编程语言被设计用于人类与计算机之间进行沟通.从技术角度来说,编程语言就是一款将执行指令传达给计算机的标准通信技术. 1.1.1 程序.软件与应用程序 在说明编程语言之前,我们需要了解什么是程序.软件与应用程序.简单地说来,编程语言提供了语法,可以让我们编写程序代码来建立程序,程序经编译建立成应用程序后,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGAY0lM.html" rel="bookmark">《Java和Android开发实战详解》&mdash;&mdash;2&period;4节Eclipse IDE的项目管理与使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.4 Eclipse IDE的项目管理与使用 Java和Android开发实战详解 一个Eclipse的工作空间可以同时拥有多个项目,在Eclipse IDE可以切换不同的工作空间,对于已有的Java项目或Java程序文件,我们可以直接导入到目前打开的工作空间或项目. 2.4.1 切换工作空间 step01Eclipse的工作空间中可以新增项目,但不能打开非此工作空间的其他项目,不过,我们可以将当前工作空间切换成其他工作空间.例如,本书每一章的范例都对应有一个工作空间,我们可以在打开第2章工作			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkwlvdp.html" rel="bookmark">《Java和Android开发实战详解》&mdash;&mdash;1&period;4节搭建Java开发环境</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.4 搭建Java开发环境 Java和Android开发实战详解 在开发Java应用程序前需要搭建Java的开发环境,首先需要安装JDK,然后即可配合编辑工具或集成开发环境来创建Java应用程序.本书主要介绍如何使用Eclipse集成开发环境来创建Java和Android应用程序. 1.4.1 安装与设置JDK 一般来说,有些集成开发环境会一并安装JDK,例如JBuilder,不过,大部分集成开发环境需要用户自行安装JDK.本书使用的JDK版本是JDK 7(Java SE Developmen			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDnavXM.html" rel="bookmark">《Java和Android开发实战详解》&mdash;&mdash;1&period;2节Java基础知识</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.2 Java基础知识 Java和Android开发实战详解 Java语言类似于C++是一种编译型语言,不过两者并不完全相同,严格说来,Java是结合编译和解释优点的一种编程语言. 1.2.1 Java平台 &quot;平台&quot;(Platform)是一种结合硬件和软件的执行环境.Java既是一种高级的面向对象的编程语言,也是一个平台.Java平台是一种纯软件平台,它可以在各种基于硬件的平台上运行,与硬件无关,主要是由JVM和Java API两个部分组成. 1．JVM虚拟机 JVM(Java Vi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmBaL3z.html" rel="bookmark">《Java和Android开发实战详解》&mdash;&mdash;1&period;3节Java语言的开发环境</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.3 Java语言的开发环境 Java和Android开发实战详解 编程语言的&quot;开发环境&quot;(Development Environment)指的是一组工具程序,可用来创建.编译和维护编程语言所构建的应用程序.一般来说,我们可以使用两种Java开发环境来创建Java应用程序. 1．终端机模式的开发环境 或称为&quot;命令行模式&quot;,对于传统MS-DOS或UNIX.Linux系统的用户,程序执行时的输入数据和输出数据都是使用&quot;命令行界面&quot;(Command-			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEK1nZp.html" rel="bookmark">《Java和Android开发实战详解》&mdash;&mdash;1&period;5节习题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				习题 Java和Android开发实战详解 1．请说明什么是程序与软件,以及编程语言的种类. 2．第五代编程语言主要是使用在人工智能和专家系统的逻辑分析语言,也称为----语言.请说明低级和高级编程语言的差异为何? 3．请比较编译型和解释型编程语言的差异.各举出两种编程语言说明. 4．请简单说明计算机是如何执行.计算机CPU访问内存数据的主要步骤是什么? 5．请问什么是Java平台?Java平台是由----和----组件组成.为什么Java是一种跨平台的编程语言? 6．请简单说明JVM是什么,并			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVdGqYM.html" rel="bookmark">《Java和Android开发实战详解》&mdash;&mdash;2&period;5节良好的Java程序代码编写风格</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.5 良好的Java程序代码编写风格Java和Android开发实战详解Java代码是由程序语句组成的,数个程序语句组合成一个程序块,每一个块拥有数行程序语句或注释,一行程序语句是一个表达式.变量和命令的程序代码. 2.5.1 程序语句Java程序由程序语句(Statement)组成,一行程序语句如同英文的一个句子,内含多个表达式.运算符或Java关键字(详见第3章的说明). 1．程序语句的范例一些Java程序语句的范例,如下所示: int total = 1234; rate = 0.05;			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/rz45Pjb.html" rel="bookmark" class="title">IMP-00020错误的解决方法</a>
					<div>
						错误|解决 今天现场人员打电话过来说导入数据时候报错,总也无法正常导入.由于需要导入的数据很大,所以本来就是以表为单位作了导出.单表的导出文件有2.9G,在导入的时候报:IMP-00020: long ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvDdrz.html" rel="bookmark" class="title">用Photoshop的批处理绘制曲线特效</a>
					<div>
						我们常常会在网上看见很多由曲线排列成的各种特效图案,其实我们完全可以用Photoshop的批处理工具Action来轻松完成. 如下图: 下面我们就开始这个简单的过程． 1．新建一个photoshop文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRyDxBb.html" rel="bookmark" class="title">电脑操作系统的引导过程概述</a>
					<div>
						操作系统的更新是相当快速的,从DOS到WIN32.95.98.ME.XP.虽然说系统一直在不断进步发展着 ,但其实每个操作系统都有各自的发展空间,也各有其的优势和劣势.比如WIN98和WIN ME,它 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrK79jp.html" rel="bookmark" class="title">关于Lambda表达式</a>
					<div>
						Lambda表达式是C#3.0的一种新语法,语法简洁 为编写匿名方法提供了更简明的函数式的句法. 我通过一个示例来说明Lambda表达式的原理: Lambda表达式和匿名方法都来源于委托 我们来看看委 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyrP0Ep.html" rel="bookmark" class="title">在SOA开发中使用WBSF动态调用业务服务，第2部分&lpar;下&rpar;</a>
					<div>
						WBSF(WebSphere Business Services Fabric)让我们在 SOA 开发中能够根据服务策略动态调用业务服务.本文通过一个具体的例子,介绍如何通过 WBSF V6.02 的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Akvmp.html" rel="bookmark" class="title">ruby杂项</a>
					<div>
						本章处理一些实际问题. 语句定界符 有些语言需要一定类型的标点,一般会是分号(;)来结束程序的每一语句.Ruby却采用了shell里的sh和csh的方便做法.一行中的多个语句由分号分开,但在行尾分号却 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAa4D2M.html" rel="bookmark" class="title">如何提高Linux系统的安全性</a>
					<div>
						导读:由于学习Linux很久了,没事讲讲关于Linux系统的问题希望对大家有所帮助.Linux系统不论在功能上.价格上或性能上都有很多优点,然而,作为开放式操作系统,它不可避免地存在一些安全隐患.关于 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgK8ymM.html" rel="bookmark" class="title">谷歌浏览器自动解除阻止插件运行方法</a>
					<div>
						  相信不少用户在使用谷歌浏览器的时候,在登陆个别网站却发现无法验证登陆,谷歌浏览器自动阻止了一些插件,那么谷歌浏览器如何设置自动解除阻止插件运行,下面小编就给大家带来谷歌浏览器验证证书控件方法. 解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKkWVp.html" rel="bookmark" class="title">百度浏览器隐身窗口真的能隐身么？</a>
					<div>
						  当然不是把你变没.在你访问私密网站时,百度浏览器就像个小秘书,贴心提醒你提醒进入隐身窗口模式,防止历史记录等相关功能记录你的私密信息,小秘密再也不怕被老婆发现!					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB2v19b.html" rel="bookmark" class="title">路由表配置及多网卡同时使用内网和外网</a>
					<div>
						  CMD命令:route 子命令1:route print 查看路由表 子命令2:route add 添加静态路由 子命令3:route delete 删除静态路由 查看 使用子命令1结果如下图 ( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKkqPab.html" rel="bookmark" class="title">host文件怎么修改</a>
					<div>
						host文件怎么修改   这个两种解决方法,不仅适用于Windows 7,Windows 8以及8.1均可尝试操作,优先建议使用方案两种的方式. 方法一:使用管理员权限打开&quot;记事本&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1EkZaM.html" rel="bookmark" class="title">Word2013中&OpenCurlyDoubleQuote;键入时自动套用格式&rdquo;生成编号的方法</a>
					<div>
						  在Word2013文档中,用户可以借助&quot;键入时自动套用格式&quot;功能,在直接输入数字的时候自动生成编号.用户首先需要启用自动编号列表自动套用选项,自动生成编号的步骤如下所述: 第1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlByRDz.html" rel="bookmark" class="title">Windows 7中如何快速删除指定注册表键值&quest;</a>
					<div>
						&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp;   Windows7 RTM 7600出现噪音杂音解决方法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1EKojM.html" rel="bookmark" class="title">VM中装Linux换ISO文件报错&amp;amp&semi;quot&semi;该光盘无法被挂载&amp;amp&semi;quot&semi;</a>
					<div>
						一.发现问题 利用VM安装Red Hat Linux的时候,第一个iso安装完毕,准备换第二个iso,报错&quot;该光盘无法被挂载&quot;. 二.解决办法 上面的菜单栏中&quot;虚拟机&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvrG1aM.html" rel="bookmark" class="title">图片-数据传输动态关系图解决方案？</a>
					<div>
						问题描述 数据传输动态关系图解决方案? 这种效果哪位做过,或者见过?谢谢了. 解决方案 如果就是这么几条线的话,直接自己绘制就可以了.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgV0dmb.html" rel="bookmark" class="title">su认证失败解决方法</a>
					<div>
						su认证失败的解决方法 Ubuntu安装后,root用户默认是被锁定了的,不允许登录,也不允许&quot;su&quot;到 root.有人说这是个不好的实践,特别是对于服务器来说.我觉得对于桌面用户 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQNK8z.html" rel="bookmark" class="title">DataV基础版如何制作单独省份地图？</a>
					<div>
						第一步 以&quot;全国业务态势&quot;模版创建可视化 因为DataV基础版不能够自由的添加地图的下各个子组件,制作省份地图需要包含&quot;区域热力&quot;这个子组件.没关系,即便您目前 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVk0Zb.html" rel="bookmark" class="title">字符串拼接方式&lpar;待商榷&rpar;</a>
					<div>
						&lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Transitional//EN&quot; &quot;http://www.w3.org/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1l4aKb.html" rel="bookmark" class="title">织梦-做一个网站，中文版和英文版各做一个，怎么样组合在一个万网主机里？</a>
					<div>
						问题描述 做一个网站,中文版和英文版各做一个,怎么样组合在一个万网主机里? 做一个网站,中文版和英文版各做一个,怎么样组合在一个万网主机里?(企业网站,非常简单) 我用织梦系统做好中文版和英文版的网站 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8kr99M.html" rel="bookmark" class="title">虚拟化技术比较 PV HVM</a>
					<div>
						很多人看到同样配置的VPS价格相差很大,甚是不理解,其实VPS使用的虚拟技术种类有很多,如OpenVZ.Xen.KVM.Xen和HVM与PV.在XEN中pv是半虚拟化,hvm是全虚拟化,pv只能用于L ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGEAGnM.html" rel="bookmark" class="title">关于的到页面对象的。。。。急</a>
					<div>
						问题描述 我的一个jsp页面,里面有好多&lt;s:textfield name=&quot;tbStaStationinfo.engineroomName&quot; theme=&quot;xht ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z40o08z.html" rel="bookmark" class="title">网站 数据库-关于网站数据库的问题</a>
					<div>
						问题描述 关于网站数据库的问题 我现在在看一些开源的社交网站的源代码.他们好像都有一个共同的特点就是好像不管是发布消息还是个人私信,都会设置一个is_del的tinyint(1)的类型,用来标记是否是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrX6Nxz.html" rel="bookmark" class="title">Python 用户登录验证的小例子&lowbar;python</a>
					<div>
						复制代码 代码如下: #!/usr/bin/python#coding=gbk class User:    def __init__(self,username,password,age,sex): ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5RWlqz.html" rel="bookmark" class="title">SMS发短信</a>
					<div>
						问题描述 需求分析:用.net(c#语言)或asp实现往手机上定时发短信的功能,短信保存在数据库(限acc,xml)中,也可RSS提取,发送方是固定的我的手机号码,接收方也是固定的号码,接收方如有回短 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b226XZb.html" rel="bookmark" class="title">对必应、谷歌、百度、搜狗及有道横向评测</a>
					<div>
						现在的http://www.aliyun.com/zixun/aggregation/39529.html&quot;&gt;搜索引擎市场再也不像以前,提交网站已经不是必要步骤了.但是要想网站轻松快速 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoqN7M.html" rel="bookmark" class="title">android-Android 的 getIntExtra问题</a>
					<div>
						问题描述 Android 的 getIntExtra问题 Android 的 getIntExtra(name, defaultValue)里 defaultValue是什么意思 解决方案 如果没有这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgwA0OM.html" rel="bookmark" class="title">Spark 生态系统组件</a>
					<div>
						Spark 生态系统以Spark Core 为核心,能够读取传统文件(如文本文件).HDFS.Amazon S3.Alluxio 和NoSQL 等数据源,利用Standalone.YARN 和Meso ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M12OArp.html" rel="bookmark" class="title">科学家盘点人体10大无用器官男性乳头居首位</a>
					<div>
						据美国媒体报道,欧洲文艺复兴时期杰出的人体解剖学家与画家达芬奇这样说道:&quot;人体是大自然中最完美的事物.&quot;但是一些人体部位似乎已经退化无用,显得多余. 创立进化论的生物学家达尔文分析 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBkkgNM.html" rel="bookmark" class="title">Asp定时执行操作 Asp定时读取数据库&lpar;网页定时操作详解&rpar;&lowbar;小偷&sol;采集</a>
					<div>
						目前定时的操作有: 一.Html页面的定时刷新(Refresh--刷新 ) 1,Refresh (刷新) 代码使用说明 说明:让网页多长时间(秒)刷新自己,或在多长时间后让网页自动链接到其它网页. 用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6GwANp.html" rel="bookmark" class="title">PHP中Session和Cookie是如何操作的&lowbar;php技巧</a>
					<div>
						Session PHP的$_SESSION可以存储当前用户数据信息,用户访问WEB网站的时候,PHP会给每个访问的用户创建一个session ID,该ID是唯一ID,保存在客户机上,而用户的会话数据是 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
